apiVersion: {{ networkpolicy_apivers }}
kind: NetworkPolicy
metadata:
{% if (policy_namespace | default(namespace)) == namespace %}
  name: {{ policy_name }}
{% else %}
  name: {{ namespace }}-{{ policy_name }}
{% endif %}
  namespace: {{ policy_namespace | default(namespace) }}
spec:
  ingress:
{% for allow in source %}
{% if (allow.namespace | default(False)) == default_namespace_match %}
{% if ingress_filter_method == 'none' %}
  - {}
{% elif ingress_filter_method == 'nodeips' %}
  - from:
{% for node in has_ingress_nodes.resources | default([]) %}
{% for addr in node.status.addresses | default([]) if addr.type == 'InternalIP' %}
    - ipBlock:
        cidr: {{ addr.address }}/32
{% endfor %}
{% endfor %}
{% if to | default(False) %}
    ports:
{% for port in (to | default([])) if port.number is defined %}
    - port: {{ port.number }}
      protocol: {{ port.proto | default('TCP') }}
{% endfor %}
{% endif %}
{% elif ingress_filter_method == 'labels' %}
  - from:
    - namespaceSelector:
        matchLabels:
          {{ network_policy_namespace_label }}: {{ allow.namespace }}
{% if to | default(False) %}
    ports:
{% for port in (to | default([])) if port.number is defined %}
    - port: {{ port.number }}
      protocol: {{ port.proto | default('TCP') }}
{% endfor %}
{% endif %}
{% endif %}
{% elif (allow.namespace | default(False)) and allow.namespace != (policy_namespace | default(namespace)) %}
  - from:
    - namespaceSelector:
        matchLabels:
          {{ network_policy_namespace_label }}: {{ allow.namespace }}
{% if to | default(False) %}
    ports:
{% for port in (to | default([])) if port.number is defined %}
    - port: {{ port.number }}
      protocol: {{ port.proto | default('TCP') }}
{% endfor %}
{% endif %}
{% else %}
  - from:
{% if allow.name | default(False) %}
    - podSelector:
        matchLabels:
          {{ allow.matchkey | default(policy_matchkey | default(network_policy_deployment_label)) }}: {{ allow.name }}
{% else %}
    - podSelector: {}
{% endif %}
{% if to | default(False) %}
    ports:
{% for port in (to | default([])) if port.number is defined %}
    - port: {{ port.number }}
      protocol: {{ port.proto | default('TCP') }}
{% endfor %}
{% endif %}
{% endif %}
{% endfor %}
{% if subject | default(False) %}
  podSelector:
    matchLabels:
      name: {{ subject }}
{% else %}
  podSelector: {}
{% endif %}
  policyTypes:
  - Ingress
